      subroutine cc_ha_1413_1615_pol (s,spr,ph3,costh3,costh5,hardpp,hardpm,hardmp,hardmm)
      implicit none!
      include 's2n_declare.h'

      real*8 sq,sqspr,qw
      real*8 hardpp,hardpm,hardmp,hardmm
      real*8 p1p2,p1p3,p1p4,p1p5,p2p3,p2p4,p2p5,p3p4,p3p5,p4p5
      real*8 ph3,cosph3,sinph3,costh3,sinth3,costh5,sinth5
      real*8 sqrtlsupdn,isqrtlsupdn
      real*8 kappaw
      complex*16 chiwspr,chiwsprc,chiws,chiwsc
      real*8 chichicwswspr
      real*8 iz1up,iz2dn,iz4mo,iz3mn,z1,z2,z3,z4
      integer*4 h1,h2,h3,h4,h5,j1,j2,i
      real*8 abs2,abs2p
      real*8 sqs
      real*8 betai
      complex*16  ampISR(2,2,2,2,2), ampFSR(2,2,2,2,2)
      complex*16  hel_ampISR(2,2,2,2,2), hel_ampFSR(2,2,2,2,2)
      real*8 amp2(2,2,2,2,2),hard2(2,2)
      complex*16 cc1(2,2), cc2(2,2)
      real*8 p1(5), p2(5), p3(5), p4(5), p5(5), q(5)
      real*8 k1(5), k2(5), k3(5), k4(5), k5(5)
      complex*16 SpAA, SpBB
      complex*16 A15A, A25A, A35A, A45A
      complex*16 B51B, B52B, B53B, B54B
      complex*16 A51A, A52A, A53A, A54A, A41A, A21A, A32A, A42A
      complex*16 A12A, A13A, A14A, A23A, A24A, A34A, A43A, A31A
      complex*16 B21B, B31B, B32B,  B41B, B42B, B43B
      complex*16 B12B, B13B, B23B,  B14B, B24B, B34B
      complex*16 B15B, B25B, B35B, B45B
      real*8 Pair
      real*8 q1,q2,q3,q4

      cmw2 = mw2
      qw = 1d0

      sq = dsqrt(s)
      sqspr = dsqrt(spr)

      cosph3 = dcos(ph3)
      sinph3 = dsin(ph3)
      sinth3 = dsqrt(1d0-costh3**2)
      sinth5 = dsqrt(1d0-costh5**2)

      sqrtlsupdn = sqrt(s**2-2d0*s*(rupm2+rdnm2)+(rupm2-rdnm2)**2)
      isqrtlsupdn = 1d0/sqrtlsupdn

      kappaw = gf*rwm2/(sqrt(2d0)*4d0*pi)/alpha
      if (irun.eq.0) then
         chiwspr = 4d0*kappaw*spr/(spr-cmw2)
      else
         chiwspr = 4d0*kappaw*spr/(spr-dcmplx(mw**2,-spr*ww/mw))
      endif
      chiwsprc = dconjg(chiwspr)

      if (irun.eq.0) then
         chiws = 4d0*kappaw*s/(s-cmw2)
      else
         chiws = 4d0*kappaw*s/(s-dcmplx(mw**2,-s*ww/mw))
      endif
      chiwsc = dconjg(chiws)

      chichicwswspr = chiws*chiwsprc+chiwsc*chiwspr

      p1p2=Pair(pg1,pg2)
      p1p3=Pair(pg1,pg3)
      p1p4=Pair(pg1,pg4)
      p1p5=Pair(pg1,pg5)
      p2p3=Pair(pg2,pg3)
      p2p4=Pair(pg2,pg4)
      p2p5=Pair(pg2,pg5)
      p3p4=Pair(pg3,pg4)
      p3p5=Pair(pg3,pg5)
      p4p5=Pair(pg4,pg5)

!-----------------------------------------------------------------------
!--- p(1) = px, p(2) = py, p(3) = pz, p(4) = e, p(5) = m ---------------
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!--- 4-momenta of particles in the laboratory reference frame as input
      p1 = pg1
      p2 = pg2
      p3 = pg3
      p4 = pg4
      p5 = pg5
!--- But we work with all momenta to zero setup
!--- Do all momenta incoming
      do i = 1,4
        p3(i) = -p3(i)
        p4(i) = -p4(i)
        p5(i) = -p5(i)
      enddo

      sqs = sqrt(s)
      sqspr = sqrt(spr)
      betai = sqrt((s-(mup-mdn)**2)*(s-(mup+mdn)**2))/s
      betaf = (spr-mmo**2)/spr

      z1=(s-spr)*(-(s+mup**2-mdn**2)+costh5*betai*s)/2d0/s
      z2=(s-spr)*(-(s-mup**2+mdn**2)-costh5*betai*s)/2d0/s
      z3=(s-spr)*(mmo**2*(1-costh3)+spr*(1+costh3))/2d0/spr
      z4=(s-spr)*(1-costh3)*(spr-mmo**2)/2d0/spr

      do h1=1,2
         do h2=1,2
           do h3=1,2
             do h4=1,2
               do h5=1,2
                 ampISR(h1,h2,h3,h4,h5)=0d0
                 ampFSR(h1,h2,h3,h4,h5)=0d0
               enddo
             enddo
           enddo
         enddo
      enddo

      q(1)=1d0;
      q(2)=0d0;
      q(3)=0d0;
      q(4)=1d0;
      q(5)=0d0;
      call S_Assoc1(p5, k5);
      call S_Assoc(p1, q, k1);
      call S_Assoc(p2, q, k2);
      call S_Assoc(p3, q, k3);
      call S_Assoc(p4, q, k4);

      A15A = SpAA(k1, k5);
      A25A = SpAA(k2, k5);
      A35A = SpAA(k3, k5);
      A45A = SpAA(k4, k5);
      A12A = SpAA(k1, k2);
      A21A = SpAA(k2, k1);
      A13A = SpAA(k1, k3);
      A31A = SpAA(k3, k1);
      A14A = SpAA(k1, k4);
      A41A = SpAA(k4, k1);
      A23A = SpAA(k2, k3);
      A32A = SpAA(k3, k2);
      A24A = SpAA(k2, k4);
      A42A = SpAA(k4, k2);
      A34A = SpAA(k3, k4);
      A43A = SpAA(k4, k3);
      A51A = SpAA(k5, k1);
      A52A = SpAA(k5, k2);
      A53A = SpAA(k5, k3);
      A54A = SpAA(k5, k4);

      B51B = SpBB(k5, k1);
      B52B = SpBB(k5, k2);
      B53B = SpBB(k5, k3);
      B54B = SpBB(k5, k4);
      B21B = SpBB(k2, k1);
      B31B = SpBB(k3, k1);
      B32B = SpBB(k3, k2);
      B41B = SpBB(k4, k1);
      B42B = SpBB(k4, k2);
      B43B = SpBB(k4, k3);

      B15B = SpBB(k1, k5);
      B25B = SpBB(k2, k5);
      B35B = SpBB(k3, k5);
      B45B = SpBB(k4, k5);
      B12B = SpBB(k1, k2);
      B13B = SpBB(k1, k3);
      B23B = SpBB(k2, k3);
      B14B = SpBB(k1, k4);
      B24B = SpBB(k2, k4);
      B34B = SpBB(k3, k4);

      q1=qup
      q2=-qdn
      q3=-1d0
      q4=0d0

      ampISR(2,1,2,2,1)=(A51A*A52A*A34A*B23B**2)*(q1/z1-q2/z2)/(z1+z2)/(spr-cmw2);
      ampISR(2,1,2,2,2)=(B15B*B25B*B34B*A41A**2)*(q1/z1-q2/z2)/(z1+z2)/(spr-cmw2);
      ampFSR(2,1,2,2,1)=-(A54A*A53A*A12A*B23B**2)*(q3/z3)/(z3+z4)/(s-cmw2);
      ampFSR(2,1,2,2,2)=-(B35B*B45B*B12B*A41A**2)*(q3/z3)/(z3+z4)/(s-cmw2);

! phase space volume
      volum =  1d0/2048d0/pi**4*(s-spr)/s**2*betaf/betai*conhc

! amplitudes squared
      do h1=1,2
        do h2=1,2
          hard2(h1,h2) = 0d0
          do h3=1,2
            do h4=1,2
              do h5=1,2
                amp2(h1,h2,h3,h4,h5) = abs2p(ampISR(h1,h2,3-h3,3-h4,3-h5),ampFSR(h1,h2,3-h3,3-h4,3-h5))
                hard2(h1,h2) = hard2(h1,h2) + amp2(h1,h2,h3,h4,h5)
              enddo
            enddo
          enddo
        enddo
      enddo

      hardpp = hard2(1,1)*volum*e**6*2d0/stw4/3d0*cfprime
      hardpm = hard2(1,2)*volum*e**6*2d0/stw4/3d0*cfprime
      hardmp = hard2(2,1)*volum*e**6*2d0/stw4/3d0*cfprime
      hardmm = hard2(2,2)*volum*e**6*2d0/stw4/3d0*cfprime

      return
      end
