      subroutine nc_si_13_13_23_1_pol (s,t,u,sigmapp,sigmapm,sigmamp,sigmamm)
      implicit none!
      include 's2n_declare.h'

      integer i,j,k,l
      real*8 sigmapp,sigmapm,sigmamp,sigmamm
      real*8 sum
      real*8 nsig
      real*8 iT,iU,isqrt3
      real*8 cth13,sth13
      complex*16 amp(2,2,2,2)
      real*8 amp2(2,2)

      iT = 1d0/t
      iU = 1d0/u
      isqrt3 = 1d0/dsqrt(3d0)

      cth13 = (u-t)/s
      sth13 = dsqrt(1d0-cth13**2)

      nsig = conhc/s/pi/96d0

      amp(2,2,2,2) = 0

      amp(2,2,2,1) = 0

      amp(2,2,1,2) = 0

      amp(2,2,1,1) = 0

      amp(2,1,2,2) =
     &+e*gs*qup*isqrt3*sth13 * (  - u*iT + t*iU )
     &+e*gs*qup*s*isqrt3*sth13 * (  - iT + iU )

      amp(2,1,2,1) =
     &+ e*gs*qup*isqrt3*sth13 * ( u*iT - t*iU )
     &+ e*gs*qup*s*isqrt3*sth13 * (  - iT - iU )

      amp(2,1,1,2) =
     &+ e*gs*qup*isqrt3*sth13 * ( u*iT - t*iU )
     &+ e*gs*qup*s*isqrt3*sth13 * ( iT + iU )

      amp(2,1,1,1) =
     &+ e*gs*qup*isqrt3*sth13 * (  - u*iT + t*iU )
     &+ e*gs*qup*s*isqrt3*sth13 * (  - iT + iU )

      amp(1,2,2,2) =
     &+ e*gs*qup*isqrt3*sth13 * (  - u*iT + t*iU )
     &+ e*gs*qup*s*isqrt3*sth13 * (  - iT + iU )

      amp(1,2,2,1) =
     &+ e*gs*qup*isqrt3*sth13 * ( u*iT - t*iU )
     &+ e*gs*qup*s*isqrt3*sth13 * ( iT + iU )

      amp(1,2,1,2) =
     &+ e*gs*qup*isqrt3*sth13 * ( u*iT - t*iU )
     &+ e*gs*qup*s*isqrt3*sth13 * (  - iT - iU )

      amp(1,2,1,1) =
     &+ e*gs*qup*isqrt3*sth13 * (  - u*iT + t*iU )
     &+ e*gs*qup*s*isqrt3*sth13 * (  - iT + iU )

      amp(1,1,2,2) = 0d0

      amp(1,1,2,1) = 0d0

      amp(1,1,1,2) = 0d0

      amp(1,1,1,1) = 0d0

      do i = 1,2
        do j = 1,2
          amp2(i,j) = 0d0
            do k = 1,2
              do l = 1,2
                amp2(i,j) = amp2(i,j)+amp(i,j,k,l)*dconjg(amp(i,j,k,l))
              enddo
            enddo
        enddo
      enddo

      sigmapp = nsig*amp2(1,1)
      sigmapm = nsig*amp2(1,2)
      sigmamp = nsig*amp2(2,1)
      sigmamm = nsig*amp2(2,2)

      return
      end
