      subroutine nc_si_13_23_13_1_pol (s,t,u,sigmapp,sigmapm,sigmamp,sigmamm)
      implicit none!
      include 's2n_declare.h'
      integer i,j,k,l
      real*8 sigmapp,sigmapm,sigmamp,sigmamm
      real*8 iT,iU,iS,cth3,sth3,cth3h,sth3h,nsig
      real*8 amp2(2,2)
      complex*16 amp(2,2,2,2)

      iT = 1d0/t
      iU = 1d0/u
      iS = 1d0/s
      cth3 = (u-t)/s
      sth3 = dsqrt(1d0-cth3**2)
      cth3h = dsqrt((1d0+cth3)/2d0)
      sth3h = dsqrt((1d0-cth3)/2d0)
      nsig = qup**2*pi*alpha*alphas*conhc/s/18d0

      amp(2,2,2,2) = (-4d0*cth3h-4d0*cth3h*t*iS)+sth3*(2d0*sth3h)
      amp(2,2,2,1) = (4d0*cth3h*t*iS)+sth3*(-2d0*sth3h+2d0*sth3h*s*iT)
      amp(2,2,1,2) = 0d0
      amp(2,2,1,1) = 0d0
      amp(2,1,2,2) = -4d0*cth3h
      amp(2,1,2,1) = 0d0
      amp(2,1,1,2) = 0d0
      amp(2,1,1,1) = 0d0
      amp(1,2,2,2) = 0d0
      amp(1,2,2,1) = 0d0
      amp(1,2,1,2) = 0d0
      amp(1,2,1,1) = -4d0*cth3h
      amp(1,1,2,2) = 0d0
      amp(1,1,2,1) = 0d0
      amp(1,1,1,2) = (4d0*cth3h*t*iS)+sth3*(-2d0*sth3h+2d0*sth3h*s*iT)
      amp(1,1,1,1) = (-4d0*cth3h-4d0*cth3h*t*iS)+sth3*(2d0*sth3h)

      do i = 1,2
        do j = 1,2
          amp2(i,j) = 0d0
            do k = 1,2
              do l = 1,2
                amp2(i,j) = amp2(i,j)+amp(i,j,k,l)*dconjg(amp(i,j,k,l))
              enddo
            enddo
        enddo
      enddo

      sigmapp = nsig*amp2(1,1)
      sigmapm = nsig*amp2(1,2)
      sigmamp = nsig*amp2(2,1)
      sigmamm = nsig*amp2(2,2)

      return
      end
