      subroutine nc_si_14_14_23_1_pol (s,t,u,sigmapp,sigmapm,sigmamp,sigmamm)
      implicit none!
      include 's2n_declare.h'
      integer i,j,k,l
      real*8 sigmapp,sigmapm,sigmamp,sigmamm
      real*8 iT,iU,cth3,nsig
      real*8 amp2(2,2)
      complex*16 amp(2,2,2,2)

      iT = 1d0/t
      iU = 1d0/u
      cth3 = (u-t)/s
      nsig = qdn**2*pi*alpha*alphas*conhc/s/18d0*(1d0-cth3**2)

      amp(2,2,2,2) = 0d0
      amp(2,2,2,1) = 0d0
      amp(2,2,1,2) = 0d0
      amp(2,2,1,1) = 0d0
      amp(2,1,2,2) = (-u*iT+t*iU)+s*(-iT+iU)
      amp(2,1,2,1) = (u*iT-t*iU)+s*(-iT-iU)
      amp(2,1,1,2) = (u*iT-t*iU)+s*(iT+iU)
      amp(2,1,1,1) = (-u*iT+t*iU)+s*(-iT+iU)
      amp(1,2,2,2) = (-u*iT+t*iU)+s*(-iT+iU)
      amp(1,2,2,1) = (u*iT-t*iU)+s*(iT+iU)
      amp(1,2,1,2) = (u*iT-t*iU)+s*(-iT-iU)
      amp(1,2,1,1) = (-u*iT+t*iU)+s*(-iT+iU)
      amp(1,1,2,2) = 0d0
      amp(1,1,2,1) = 0d0
      amp(1,1,1,2) = 0d0
      amp(1,1,1,1) = 0d0

      do i = 1,2
        do j = 1,2
          amp2(i,j) = 0d0
            do k = 1,2
              do l = 1,2
                amp2(i,j) = amp2(i,j)+amp(i,j,k,l)*dconjg(amp(i,j,k,l))
              enddo
            enddo
        enddo
      enddo

      sigmapp = nsig*amp2(1,1)
      sigmapm = nsig*amp2(1,2)
      sigmamp = nsig*amp2(2,1)
      sigmamm = nsig*amp2(2,2)

      return
      end
